// Copyright (C) 2018 Freetech Solutions


/* global REMOVER_CAMPO Urls gettext */
/* global AGREGAR_VALIDACION */

var languageCode = $('#languageCode').val();
var agentes_select2, campanas_select2, grupos_select2;
const idDomGrupos = '#filtroGruposAgentes';
const idDomCampanas = '#filtroCampanas';
const idDomTipoCampana = '#filtroTiposCampanas';
var $filtroAgentes = $('#filtroAgentes').find('select');
var $filtroGruposAgentes = $(idDomGrupos).find('select');
var $filtroCampanas = $(idDomCampanas).find('select');
var $filtroTipoCampana = $(idDomTipoCampana).find('select');

function mostrarFiltroConexion(
    valorTipoConexion, $filtroExitosas, $filtroFallidas, $filtroDuracionLlamada,
    $filtroCalificacionLlamada) {
    if (valorTipoConexion == 0) {
        // TODAS las llamadas
        $filtroExitosas.attr('class', 'hidden');
        $filtroFallidas.attr('class', 'hidden');
        $filtroDuracionLlamada.attr('class', 'hidden');
        $filtroCalificacionLlamada.attr('class', 'hidden');
    }
    else {
        if (valorTipoConexion == 1) {
            // TODAS las exitosas
            $filtroExitosas.attr('class', '');
            $filtroFallidas.attr('class', 'hidden');
            $filtroDuracionLlamada.attr('class', '');
            $filtroCalificacionLlamada.attr('class', '');
        }
        else {
            // TODAS las fallidas
            $filtroExitosas.attr('class', 'hidden');
            $filtroFallidas.attr('class', '');
            $filtroDuracionLlamada.attr('class', 'hidden');
            $filtroCalificacionLlamada.attr('class', 'hidden');
        }
    }
}


function bindingsFiltrosFinalizacionLlamada() {
    var $filtroTipoConexion = $('#filtroTipoConexion select');
    var $filtroExitosas = $('#filtroExitosas');
    var $filtroFallidas = $('#filtroFallidas');
    var $filtroDuracionLlamada = $('#filtroDuracionLlamada');
    var $filtroCalificacionLlamada = $('#filtroCalificacionLlamada');
    $filtroTipoConexion.change(function () {
        var valorTipoConexion = $(this).children('option:selected').val();
        mostrarFiltroConexion(valorTipoConexion, $filtroExitosas, $filtroFallidas,
            $filtroDuracionLlamada, $filtroCalificacionLlamada);
    });
    mostrarFiltroConexion(
        $filtroTipoConexion.val(), $filtroExitosas, $filtroFallidas,
        $filtroDuracionLlamada, $filtroCalificacionLlamada);
}


function adicionarEstiloDiasSemana() {
    $('#id_dia_semana').attr('class', 'list-group');
}

function adicionarDatePicker() {
    var fechaInicio = $('#id_fecha_inicio').val();
    var fechaFinal = $('#id_fecha_fin').val();
    $('#id_fecha_inicio').datetimepicker({format: 'L', locale: languageCode});
    $('#id_fecha_fin').datetimepicker({format: 'L', locale: languageCode});
    if (fechaInicio != '' && fechaFinal != '') {
    /* si los entradas de fecha tenían valor se los restituimos */
        $('#id_fecha_inicio').val(fechaInicio);
        $('#id_fecha_fin').val(fechaFinal);
    }
}

function getRequestData() {
    return {
        'groups': $filtroGruposAgentes.val(),
        'campaigns': $filtroCampanas.val(),
        'campaign_type': $filtroTipoCampana.val()
    };
}

function setData({agentes, grupos, campanas}) {
    // Agentes
    $filtroAgentes.empty();
    $filtroAgentes.append($('<option></option>').val('0').html(gettext('Todos')));
    $filtroAgentes.append($('<option></option>').val('00').html(gettext('Seleccionar Todos')));
    agentes_select2.val('0');
    $.each(agentes, function () {
        $filtroAgentes.append($('<option></option>').val(this[0]).html(this[1]));
    });

    // Grupos
    const selectedGroups = $filtroGruposAgentes.val();
    $filtroGruposAgentes.empty();
    $filtroGruposAgentes.append($('<option></option>').val('0').html(gettext('Todos')));
    $.each(grupos, function () {
        $filtroGruposAgentes.append($('<option></option>').val(this[0]).html(this[1]));
    });
    grupos_select2.val(selectedGroups);

    // Campanas
    const selectedCampaings = $filtroCampanas.val();
    $filtroCampanas.empty();
    $filtroCampanas.append($('<option></option>').val('0').html(gettext('Todos')));
    $.each(campanas, function () {
        $filtroCampanas.append($('<option></option>').val(this[0]).html(this[1]));
    });
    campanas_select2.val(selectedCampaings);
}

function getAjaxOptions () {
    return {
        url: Urls.api_datos_por_filtros_de_objetos(),
        type: 'POST',
        data: getRequestData(),
        success: function(data){
            setData(data);
        }
    };
}

function eventosParaFiltrosDeObjetos() {
    // Tipo de Campanas change event
    $(idDomTipoCampana).change(function () {
        $.ajax(getAjaxOptions());
    });

    // Grupos change event
    $(idDomGrupos).change(function () {
        $.ajax(getAjaxOptions());
    });

    // Campanas change event
    $(idDomCampanas).change(function () {
        $.ajax(getAjaxOptions());
    });
}

$(function() {
    $('.tiempo').datetimepicker({format: 'HH:mm'});
    adicionarDatePicker();
    adicionarEstiloDiasSemana();
    bindingsFiltrosFinalizacionLlamada();
    eventosParaFiltrosDeObjetos();
    agentes_select2 = $('#id_agentes').select2();
    campanas_select2 = $('#id_campanas').select2();
    grupos_select2 = $('#id_grupos_agentes').select2();
    // setExclusiveAllSelection(agentes_select2);
    initializeAgentSelector();
    setExclusiveAllSelection(campanas_select2);
    setExclusiveAllSelection(grupos_select2);
    initApplyButtonDeactivation();
});

function setExclusiveAllSelection(selector) {
    selector.on('select2:selecting', function (e) {
        var data = e.params.args.data;
        if (data.element.value == '0') {
            selector.val('0');
        }
        else {
            var value = selector.val();
            if (value) {
                var selected = value.filter(option => option != '0');
                selector.val(selected);
            }
        }
    });
    selector.on('select2:unselecting', function (e) {
        if (selector.val().length == 1) {
            selector.val('0');
            if (e.params.args.data.element.value == '0'){
                e.preventDefault();
                return false;
            }
        }
    });
}

function initializeAgentSelector(){
    var selector = agentes_select2;
    var newOption = new Option(gettext('Seleccionar Todos'), '00', false, false);
    $(newOption).insertAfter(selector.find('option[value="0"]'));
    selector.on('select2:selecting', function (e) {
        var data = e.params.args.data;
        if (data.element.value == '0') {
            selector.val('0');
        }
        else if (data.element.value == '00') {
            let options = [];
            selector.find('option').each(function (i, opt) {
                if (opt.value != '0' && opt.value != '00')
                    options.push(opt.value);
            });
            setTimeout(function() {selector.val(options).trigger('change');}, 0);
        }
        else {
            var value = selector.val();
            if (value) {
                var selected = value.filter(option => option != '0');
                selector.val(selected);
            }
        }
    });
    selector.on('select2:unselecting', function (e) {
        if (selector.val().length == 1) {
            selector.val('0');
            if (e.params.args.data.element.value == '0'){
                e.preventDefault();
                return false;
            }
        }
    });
}

var validacionTiempo = $('#validaciontiempo').val();
$('.validacionTiempoTr').formset({
    addText: AGREGAR_VALIDACION,
    deleteText: REMOVER_CAMPO,
    prefix: validacionTiempo,
    addCssClass: 'btn btn-outline-primary',
    deleteCssClass: 'btn btn-outline-danger deleteFormset',
    formCssClass: 'dynamic-formset',
    added: function (row) {
        $(row.find('.tiempo')).each(function (index) {
            $(this).datetimepicker({format: 'HH:mm', locale: languageCode});
            if (index == 0) {
                $(this).val('9:00');
            }
            else {
                $(this).val('18:00');
            }
        });
    }
});

function initApplyButtonDeactivation() {
    $('#filter_form').submit(function(e) {
        $('#submit_msg').show();
        $('#id_enviar_filtro').attr('disabled', true);
    });
}